/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER         "0.1.1"
#define BUFFSZ      4096
#define IP          "IP="
#define USER        "User="
#define PASS        "Password="
#define PORT        "Port="

#ifndef WIN32
    #define strnicmp strncasecmp
#endif
#ifndef u_char
    typedef unsigned char   u_char;
#endif



void servu_pwddec(u_char *pwd, int len);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    u_char  buff[BUFFSZ + 1],
            *p,
            *c;


    setbuf(stdout, NULL);

    fputs("\n"
        "Serv-U admin servers passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <ServUAdmin.ini>\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("- open file %s\n", argv[1]);
    fd = fopen(argv[1], "rt");
    if(!fd) std_err();

    while(fgets(buff, BUFFSZ, fd)) {
        if(!strnicmp(buff, IP, sizeof(IP) - 1)) {
            fputc('\n', stdout);
            fputs(buff, stdout);
        } else if(!strnicmp(buff, PORT, sizeof(PORT) - 1)) {
            fputs(buff, stdout);
        } else if(!strnicmp(buff, USER, sizeof(USER) - 1)) {
            fputs(buff, stdout);
        } else if(!strnicmp(buff, USER, sizeof(USER) - 1)) {
            fputs(buff, stdout);
        } else if(!strnicmp(buff, PASS, sizeof(PASS) - 1)) {
            for(c = buff; *c > 0xd; c++);
            *c = 0;

            p = buff + sizeof(PASS) - 1;
            servu_pwddec(p, c - p);
            printf("%s\n", buff);
        }
    }

    fclose(fd);
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void servu_pwddec(u_char *pwd, int len) {
    int             tmp,
                    i = 0;
    u_char          *out;
    const u_char    servudata[] =
                        "$@#43k;#0l,:>nklsj$#902mlkn+-_l";

    len >>= 1;
    out = pwd;
    while(len--) {
        sscanf(pwd, "%02X", &tmp);
        *out++ = tmp ^ servudata[i++];
        pwd += 2;
        if(i == sizeof(servudata)) i = 0;
    }
    *out = 0;
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


